diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/traffic-control/model/codel-queue-disc.cc ns-3.32/src/traffic-control/model/codel-queue-disc.cc
--- ns-3.31/src/traffic-control/model/codel-queue-disc.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/traffic-control/model/codel-queue-disc.cc	2020-10-06 15:35:43.000000000 -0700
@@ -78,6 +78,11 @@
                    BooleanValue (false),
                    MakeBooleanAccessor (&CoDelQueueDisc::m_useEcn),
                    MakeBooleanChecker ())
+    .AddAttribute ("UseL4s",
+                   "True to use L4S (only ECT1 packets are marked at CE threshold)",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&CoDelQueueDisc::m_useL4s),
+                   MakeBooleanChecker ())
     .AddAttribute ("MaxSize",
                    "The maximum number of packets/bytes accepted by this queue disc.",
                    QueueSizeValue (QueueSize (QueueSizeUnit::BYTES, 1500 * DEFAULT_CODEL_LIMIT)),
@@ -239,6 +244,29 @@
       NS_LOG_LOGIC ("Queue empty");
       return 0;
     }
+  uint32_t ldelay = Time2CoDel (Simulator::Now () - item->GetTimeStamp ());
+  if (item && m_useL4s)
+    {
+      uint8_t tosByte = 0;
+      if (item->GetUint8Value (QueueItem::IP_DSFIELD, tosByte) && (((tosByte & 0x3) == 1) || (tosByte & 0x3) == 3))
+        {
+          if ((tosByte & 0x3) == 1)
+            {
+              NS_LOG_DEBUG ("ECT1 packet " << static_cast<uint16_t> (tosByte & 0x3));
+            }
+          else
+            {
+              NS_LOG_DEBUG ("CE packet " << static_cast<uint16_t> (tosByte & 0x3));
+            }
+
+          if (CoDelTimeAfter (ldelay, Time2CoDel (m_ceThreshold)) && Mark (item, CE_THRESHOLD_EXCEEDED_MARK))
+            {
+              NS_LOG_LOGIC ("Marking due to CeThreshold " << m_ceThreshold.GetSeconds ());
+            }
+          return item;
+        }
+    }
+
   uint32_t now = CoDelGetTime ();
 
   NS_LOG_LOGIC ("Popped " << item);
@@ -247,6 +275,7 @@
 
   // Determine if item should be dropped
   bool okToDrop = OkToDrop (item, now);
+  bool isMarked = false;
 
   if (m_dropping)
     { // In the dropping state (sojourn time has gone above target and hasn't come down yet)
@@ -272,6 +301,7 @@
               // hence the while loop.
               if (m_useEcn && Mark (item, TARGET_EXCEEDED_MARK))
                 {
+                  isMarked = true;
                   NS_LOG_LOGIC ("Sojourn time is still above target and it's time for next drop or mark; marking " << item);
                   NS_LOG_LOGIC ("Running ControlLaw for input m_dropNext: " << (double)m_dropNext / 1000000);
                   m_dropNext = ControlLaw (now, Time2CoDel (m_interval), m_recInvSqrt);
@@ -315,6 +345,7 @@
         {
           if (m_useEcn && Mark (item, TARGET_EXCEEDED_MARK))
             {
+              isMarked = true;
               NS_LOG_LOGIC ("Sojourn time goes above target, marking the first packet " << item << " and entering the dropping state");
             }
           else
@@ -355,8 +386,12 @@
         }
     }
   end:
-  uint32_t ldelay = Time2CoDel (Simulator::Now () - item->GetTimeStamp ());
-  if (item && m_useEcn && CoDelTimeAfter (ldelay, Time2CoDel (m_ceThreshold)) && Mark (item, CE_THRESHOLD_EXCEEDED_MARK))
+  ldelay = Time2CoDel (Simulator::Now () - item->GetTimeStamp ());
+  // In Linux, this branch of code is executed even if the packet has been marked
+  // according to the target delay above. If the ns-3 code were to do the same here,
+  // it would result in two counts of mark in the queue statistics. Therefore, we
+  // use the isMarked flag to suppress a second attempt at marking.
+  if (!isMarked && item && !m_useL4s && m_useEcn && CoDelTimeAfter (ldelay, Time2CoDel (m_ceThreshold)) && Mark (item, CE_THRESHOLD_EXCEEDED_MARK))
     {
       NS_LOG_LOGIC ("Marking due to CeThreshold " << m_ceThreshold.GetSeconds ());
     }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/traffic-control/model/codel-queue-disc.h ns-3.32/src/traffic-control/model/codel-queue-disc.h
--- ns-3.31/src/traffic-control/model/codel-queue-disc.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/traffic-control/model/codel-queue-disc.h	2020-10-06 15:35:43.000000000 -0700
@@ -202,6 +202,7 @@
   virtual void InitializeParams (void);
 
   bool m_useEcn;                          //!< True if ECN is used (packets are marked instead of being dropped)
+  bool m_useL4s;                          //!< True if L4S is used (ECT1 packets are marked at CE threshold)
   uint32_t m_minBytes;                    //!< Minimum bytes in queue to allow a packet drop
   Time m_interval;                        //!< 100 ms sliding minimum time window width
   Time m_target;                          //!< 5 ms target queue delay
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/traffic-control/model/fq-codel-queue-disc.cc ns-3.32/src/traffic-control/model/fq-codel-queue-disc.cc
--- ns-3.31/src/traffic-control/model/fq-codel-queue-disc.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/traffic-control/model/fq-codel-queue-disc.cc	2020-10-06 15:35:43.000000000 -0700
@@ -163,6 +163,11 @@
                    UintegerValue (8),
                    MakeUintegerAccessor (&FqCoDelQueueDisc::m_setWays),
                    MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("UseL4s",
+                   "True to use L4S (only ECT1 packets are marked at CE threshold)",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&FqCoDelQueueDisc::m_useL4s),
+                   MakeBooleanChecker ())
   ;
   return tid;
 }
@@ -269,6 +274,7 @@
         {
           codel->SetAttribute ("UseEcn", BooleanValue (m_useEcn));
           codel->SetAttribute ("CeThreshold", TimeValue (m_ceThreshold));
+          codel->SetAttribute ("UseL4s", BooleanValue (m_useL4s));
         }
       qd->Initialize ();
       flow->SetQueueDisc (qd);
@@ -429,6 +435,14 @@
       return false;
     }
 
+  if (m_useL4s)
+    {
+      NS_ABORT_MSG_IF (m_ceThreshold == Time::Max(), "CE threshold not set");
+      if (m_useEcn == false)
+        {
+          NS_LOG_WARN ("Enabling ECN as L4S mode is enabled");
+        }
+    }
   return true;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/traffic-control/model/fq-codel-queue-disc.h ns-3.32/src/traffic-control/model/fq-codel-queue-disc.h
--- ns-3.31/src/traffic-control/model/fq-codel-queue-disc.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/traffic-control/model/fq-codel-queue-disc.h	2020-10-06 15:35:43.000000000 -0700
@@ -172,6 +172,7 @@
   uint32_t m_perturbation;   //!< hash perturbation value
   Time m_ceThreshold;        //!< Threshold above which to CE mark
   bool m_enableSetAssociativeHash; //!< whether to enable set associative hash
+  bool m_useL4s;             //!< True if L4S is used (ECT1 packets are marked at CE threshold)
 
   std::list<Ptr<FqCoDelFlow> > m_newFlows;    //!< The list of new flows
   std::list<Ptr<FqCoDelFlow> > m_oldFlows;    //!< The list of old flows
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/traffic-control/model/pie-queue-disc.cc ns-3.32/src/traffic-control/model/pie-queue-disc.cc
--- ns-3.31/src/traffic-control/model/pie-queue-disc.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/traffic-control/model/pie-queue-disc.cc	2020-10-06 15:35:43.000000000 -0700
@@ -63,7 +63,7 @@
                    MakeDoubleChecker<double> ())
     .AddAttribute ("Tupdate",
                    "Time period to calculate drop probability",
-                   TimeValue (Seconds (0.03)),
+                   TimeValue (MilliSeconds (15)),
                    MakeTimeAccessor (&PieQueueDisc::m_tUpdate),
                    MakeTimeChecker ())
     .AddAttribute ("Supdate",
@@ -79,19 +79,49 @@
                    MakeQueueSizeChecker ())
     .AddAttribute ("DequeueThreshold",
                    "Minimum queue size in bytes before dequeue rate is measured",
-                   UintegerValue (10000),
+                   UintegerValue (16384),
                    MakeUintegerAccessor (&PieQueueDisc::m_dqThreshold),
                    MakeUintegerChecker<uint32_t> ())
     .AddAttribute ("QueueDelayReference",
                    "Desired queue delay",
-                   TimeValue (Seconds (0.02)),
+                   TimeValue (MilliSeconds (15)),
                    MakeTimeAccessor (&PieQueueDisc::m_qDelayRef),
                    MakeTimeChecker ())
     .AddAttribute ("MaxBurstAllowance",
-                   "Current max burst allowance in seconds before random drop",
-                   TimeValue (Seconds (0.1)),
+                   "Current max burst allowance before random drop",
+                   TimeValue (MilliSeconds (15)),
                    MakeTimeAccessor (&PieQueueDisc::m_maxBurst),
                    MakeTimeChecker ())
+    .AddAttribute ("UseDequeueRateEstimator",
+                   "Enable/Disable usage of Dequeue Rate Estimator",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&PieQueueDisc::m_useDqRateEstimator),
+                   MakeBooleanChecker ())
+    .AddAttribute ("UseCapDropAdjustment",
+                   "Enable/Disable Cap Drop Adjustment feature mentioned in RFC 8033",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&PieQueueDisc::m_isCapDropAdjustment),
+                   MakeBooleanChecker ())
+    .AddAttribute ("UseEcn",
+                   "True to use ECN (packets are marked instead of being dropped)",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&PieQueueDisc::m_useEcn),
+                   MakeBooleanChecker ())
+    .AddAttribute ("MarkEcnThreshold",
+                   "ECN marking threshold (RFC 8033 suggests 0.1 (i.e., 10%) default)",
+                   DoubleValue (0.1),
+                   MakeDoubleAccessor (&PieQueueDisc::m_markEcnTh),
+                   MakeDoubleChecker<double> (0,1))
+    .AddAttribute ("UseDerandomization",
+                   "Enable/Disable Derandomization feature mentioned in RFC 8033",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&PieQueueDisc::m_useDerandomization),
+                   MakeBooleanChecker ())
+    .AddAttribute ("ActiveThreshold",
+                   "Threshold for activating PIE (disabled by default)",
+                   TimeValue (Time::Max ()),
+                   MakeTimeAccessor (&PieQueueDisc::m_activeThreshold),
+                   MakeTimeChecker ())
   ;
 
   return tid;
@@ -122,7 +152,6 @@
 Time
 PieQueueDisc::GetQueueDelay (void)
 {
-  NS_LOG_FUNCTION (this);
   return m_qDelay;
 }
 
@@ -145,18 +174,45 @@
     {
       // Drops due to queue limit: reactive
       DropBeforeEnqueue (item, FORCED_DROP);
+      m_accuProb = 0;
       return false;
     }
-  else if (DropEarly (item, nQueued.GetValue ()))
+  else if ((m_activeThreshold == Time::Max () || m_active) && DropEarly (item, nQueued.GetValue ()))
     {
-      // Early probability drop: proactive
-      DropBeforeEnqueue (item, UNFORCED_DROP);
-      return false;
+      if (!m_useEcn || m_dropProb >= m_markEcnTh || !Mark (item, UNFORCED_MARK))
+        {
+          // Early probability drop: proactive
+          DropBeforeEnqueue (item, UNFORCED_DROP);
+          m_accuProb = 0;
+          return false;
+        }
     }
 
   // No drop
   bool retval = GetInternalQueue (0)->Enqueue (item);
 
+  // If the queue is over a certain threshold, Turn ON PIE
+  if (m_activeThreshold != Time::Max () && !m_active && m_qDelay >= m_activeThreshold)
+    {
+      m_active = true;
+      m_qDelayOld = Time (Seconds (0));
+      m_dropProb = 0;
+      m_inMeasurement = true;
+      m_dqCount = 0;
+      m_avgDqRate = 0;
+      m_burstAllowance = m_maxBurst;
+      m_accuProb = 0;
+      m_dqStart = Simulator::Now ().GetSeconds ();
+    }
+
+  // If queue has been Idle for a while, Turn OFF PIE
+  // Reset Counters when accessing the queue after some idle period if PIE was active before
+  if (m_activeThreshold != Time::Max () && m_dropProb == 0 && m_qDelayOld.GetMilliSeconds () == 0 && m_qDelay.GetMilliSeconds () == 0)
+    {
+      m_active = false;
+      m_inMeasurement = false ;
+    }
+
   // If Queue::Enqueue fails, QueueDisc::DropBeforeEnqueue is called by the
   // internal queue because QueueDisc::AddInternalQueue sets the trace callback
 
@@ -177,6 +233,8 @@
   m_dqStart = 0;
   m_burstState = NO_BURST;
   m_qDelayOld = Time (Seconds (0));
+  m_accuProb = 0.0;
+  m_active = false;
 }
 
 bool PieQueueDisc::DropEarly (Ptr<QueueDiscItem> item, uint32_t qSize)
@@ -202,9 +260,8 @@
     {
       p = p * packetSize / m_meanPktSize;
     }
-  bool earlyDrop = true;
-  double u =  m_uv->GetValue ();
 
+  // Safeguard PIE to be work conserving (Section 4.1 of RFC 8033)
   if ((m_qDelayOld.GetSeconds () < (0.5 * m_qDelayRef.GetSeconds ())) && (m_dropProb < 0.2))
     {
       return false;
@@ -218,11 +275,25 @@
       return false;
     }
 
-  if (u > p)
+  if (m_useDerandomization)
     {
-      earlyDrop = false;
+      if (m_dropProb == 0)
+        {
+          m_accuProb = 0;
+        }
+      m_accuProb += m_dropProb;
+      if (m_accuProb < 0.85)
+        {
+          return false;
+        }
+      else if (m_accuProb >= 8.5)
+        {
+          return true;
+        }
     }
-  if (!earlyDrop)
+
+  double u =  m_uv->GetValue ();
+  if (u > p)
     {
       return false;
     }
@@ -236,17 +307,25 @@
   Time qDelay;
   double p = 0.0;
   bool missingInitFlag = false;
-  if (m_avgDqRate > 0)
+
+  if (m_useDqRateEstimator)
     {
-      qDelay = Time (Seconds (GetInternalQueue (0)->GetNBytes () / m_avgDqRate));
+      if (m_avgDqRate > 0)
+        {
+          qDelay = Time (Seconds (GetInternalQueue (0)->GetNBytes () / m_avgDqRate));
+        }
+      else
+        {
+          qDelay = Time (Seconds (0));
+          missingInitFlag = true;
+        }
+      m_qDelay = qDelay;
     }
   else
     {
-      qDelay = Time (Seconds (0));
-      missingInitFlag = true;
+      qDelay = m_qDelay;
     }
-
-  m_qDelay = qDelay;
+  NS_LOG_DEBUG ("Queue delay while calculating probability: " << qDelay.GetMilliSeconds () << "ms");
 
   if (m_burstAllowance.GetSeconds () > 0)
     {
@@ -255,7 +334,19 @@
   else
     {
       p = m_a * (qDelay.GetSeconds () - m_qDelayRef.GetSeconds ()) + m_b * (qDelay.GetSeconds () - m_qDelayOld.GetSeconds ());
-      if (m_dropProb < 0.001)
+      if (m_dropProb < 0.000001)
+        {
+          p /= 2048;
+        }
+      else if (m_dropProb < 0.00001)
+        {
+          p /= 512;
+        }
+      else if (m_dropProb < 0.0001)
+        {
+          p /= 128;
+        }
+      else if (m_dropProb < 0.001)
         {
           p /= 32;
         }
@@ -267,19 +358,15 @@
         {
           p /= 2;
         }
-      else if (m_dropProb < 1)
-        {
-          p /= 0.5;
-        }
-      else if (m_dropProb < 10)
-        {
-          p /= 0.125;
-        }
       else
         {
-          p /= 0.03125;
+          // The pseudocode in Section 4.2 of RFC 8033 suggests to use this for
+          // assignment of p, but this assignment causes build failure on Mac OS
+          // p = p;
         }
-      if ((m_dropProb >= 0.1) && (p > 0.02))
+
+      // Cap Drop Adjustment (Section 5.5 of RFC 8033)
+      if (m_isCapDropAdjustment && (m_dropProb >= 0.1) && (p > 0.02))
         {
           p = 0.02;
         }
@@ -288,17 +375,27 @@
   p += m_dropProb;
 
   // For non-linear drop in prob
-
+  // Decay the drop probability exponentially (Section 4.2 of RFC 8033)
   if (qDelay.GetSeconds () == 0 && m_qDelayOld.GetSeconds () == 0)
     {
       p *= 0.98;
     }
-  else if (qDelay.GetSeconds () > 0.2)
+
+  // bound the drop probability (Section 4.2 of RFC 8033)
+  if (p < 0)
     {
-      p += 0.02;
+      m_dropProb = 0;
+    }
+  else if (p > 1)
+    {
+      m_dropProb = 1;
+    }
+  else
+    {
+      m_dropProb = p;
     }
 
-  m_dropProb = (p > 0) ? p : 0;
+  // Section 4.4 #2
   if (m_burstAllowance < m_tUpdate)
     {
       m_burstAllowance =  Time (Seconds (0));
@@ -357,51 +454,62 @@
 
   // if not in a measurement cycle and the queue has built up to dq_threshold,
   // start the measurement cycle
-
-  if ( (GetInternalQueue (0)->GetNBytes () >= m_dqThreshold) && (!m_inMeasurement) )
-    {
-      m_dqStart = now;
-      m_dqCount = 0;
-      m_inMeasurement = true;
-    }
-
-  if (m_inMeasurement)
+  if (m_useDqRateEstimator)
     {
-      m_dqCount += pktSize;
-
-      // done with a measurement cycle
-      if (m_dqCount >= m_dqThreshold)
+      if ( (GetInternalQueue (0)->GetNBytes () >= m_dqThreshold) && (!m_inMeasurement) )
         {
+          m_dqStart = now;
+          m_dqCount = 0;
+          m_inMeasurement = true;
+        }
 
-          double tmp = now - m_dqStart;
+      if (m_inMeasurement)
+        {
+          m_dqCount += pktSize;
 
-          if (tmp > 0)
+          // done with a measurement cycle
+          if (m_dqCount >= m_dqThreshold)
             {
-              if (m_avgDqRate == 0)
+
+              double tmp = now - m_dqStart;
+
+              if (tmp > 0)
                 {
-                  m_avgDqRate = m_dqCount / tmp;
+                  if (m_avgDqRate == 0)
+                    {
+                      m_avgDqRate = m_dqCount / tmp;
+                    }
+                  else
+                    {
+                      m_avgDqRate = (0.5 * m_avgDqRate) + (0.5 * (m_dqCount / tmp));
+                    }
+                }
+              NS_LOG_DEBUG ("Average Dequeue Rate after Dequeue: " << m_avgDqRate);
+
+              // restart a measurement cycle if there is enough data
+              if (GetInternalQueue (0)->GetNBytes () > m_dqThreshold)
+                {
+                  m_dqStart = now;
+                  m_dqCount = 0;
+                  m_inMeasurement = true;
                 }
               else
                 {
-                  m_avgDqRate = (0.5 * m_avgDqRate) + (0.5 * (m_dqCount / tmp));
+                  m_dqCount = 0;
+                  m_inMeasurement = false;
                 }
             }
-
-          // restart a measurement cycle if there is enough data
-          if (GetInternalQueue (0)->GetNBytes () > m_dqThreshold)
-            {
-              m_dqStart = now;
-              m_dqCount = 0;
-              m_inMeasurement = true;
-            }
-          else
-            {
-              m_dqCount = 0;
-              m_inMeasurement = false;
-            }
         }
     }
+  else
+    {
+      m_qDelay = Time (Seconds (now - item->GetTimeStamp ().GetSeconds ()));
 
+      if (GetInternalQueue (0)->GetNBytes () == 0)
+        {
+          m_qDelay = Time (Seconds (0));
+        }
+    }
   return item;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/traffic-control/model/pie-queue-disc.h ns-3.32/src/traffic-control/model/pie-queue-disc.h
--- ns-3.31/src/traffic-control/model/pie-queue-disc.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/traffic-control/model/pie-queue-disc.h	2020-10-06 15:35:43.000000000 -0700
@@ -38,6 +38,7 @@
 
 #define BURST_RESET_TIMEOUT 1.5
 
+class PieQueueDiscTestCase;  // Forward declaration for unit test
 namespace ns3 {
 
 class TraceContainer;
@@ -83,7 +84,6 @@
    * \returns The current queue delay.
    */
   Time GetQueueDelay (void);
-
   /**
    * Assign a fixed random variable stream number to the random variables
    * used by this model.  Return the number of streams (possibly zero) that
@@ -97,6 +97,7 @@
   // Reasons for dropping packets
   static constexpr const char* UNFORCED_DROP = "Unforced drop";  //!< Early probability drops: proactive
   static constexpr const char* FORCED_DROP = "Forced drop";      //!< Drops due to queue limit: reactive
+  static constexpr const char* UNFORCED_MARK = "Unforced mark";  //!< Early probability marks: proactive
 
 protected:
   /**
@@ -105,6 +106,7 @@
   virtual void DoDispose (void);
 
 private:
+  friend class::PieQueueDiscTestCase;         // Test code
   virtual bool DoEnqueue (Ptr<QueueDiscItem> item);
   virtual Ptr<QueueDiscItem> DoDequeue (void);
   virtual bool CheckConfig (void);
@@ -140,6 +142,12 @@
   double m_a;                                   //!< Parameter to pie controller
   double m_b;                                   //!< Parameter to pie controller
   uint32_t m_dqThreshold;                       //!< Minimum queue size in bytes before dequeue rate is measured
+  bool m_useDqRateEstimator;                    //!< Enable/Disable usage of dequeue rate estimator for queue delay calculation
+  bool  m_isCapDropAdjustment;                  //!< Enable/Disable Cap Drop Adjustment feature mentioned in RFC 8033
+  bool m_useEcn;                                //!< Enable ECN Marking functionality
+  bool m_useDerandomization;                    //!< Enable Derandomization feature mentioned in RFC 8033
+  double m_markEcnTh;                           //!< ECN marking threshold (default 10% as suggested in RFC 8033)
+  Time m_activeThreshold;                       //!< Threshold for activating PIE (disabled by default)
 
   // ** Variables maintained by PIE
   double m_dropProb;                            //!< Variable used in calculation of drop probability
@@ -154,6 +162,8 @@
   uint64_t m_dqCount;                           //!< Number of bytes departed since current measurement cycle starts
   EventId m_rtrsEvent;                          //!< Event used to decide the decision of interval of drop probability calculation
   Ptr<UniformRandomVariable> m_uv;              //!< Rng stream
+  double m_accuProb;                            //!< Accumulated drop probability
+  bool m_active;                                //!< Indicates whether PIE is in active state or not
 };
 
 };   // namespace ns3
